<?php /* $Id */
//Copyright (C) 2011 Nicolas Gudino <asternic@gmail.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of version 2 the GNU General Public
//License as published by the Free Software Foundation.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.


$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$itemid = isset($_REQUEST['itemid'])?$_REQUEST['itemid']:'';
$dispnum = "fop2buttons";

$tabindex=0;
$sorting="";

//if submitting form, update database
switch ($action) {
case "edit":
    $result = fop2_buttonsedit($_POST);
    needreload();
    break;
case "refresh":
    $result = fop2_buttonsrefresh($_POST);
    needreload();
    break;
case "sortname":
    $sorting="name";
    break;
case "sortnumber":
    $sorting="number";
    break;
case "sort":
    fop2SetButtonOrder($_REQUEST);
    needreload();
    die();
    break;
}

$botonesdefinidos = fop2_list_botones();
$buttons          = fop2_list_buttons();

//$res = core_devices_list('all','full',true);
//$res = core_trunks_list();
//$res = fop2_list_botones();
//$res = fop2_all_freepbx_label();
//$res = fop2_all_freepbx_buttons();
//echo "<pre>";
//print_r($res);
//echo "</pre>";


?>

<!--/div-->

<div class="content">
    <h2><?php echo _("Edit button options"); ?></h2>
    <form autocomplete="off" name="edit" action="<?php $_SERVER['PHP_SELF'] ?>" method="post" onsubmit="return edit_onsubmit();">
    <input type="hidden" name="type"     value="tool">
    <input type="hidden" name="display"  value="<?php echo $dispnum?>">
    <input type="hidden" name="action"   value="edit">
    <input type="hidden" name="deptname" value="<?php echo $_SESSION["AMP_user"]->_deptname ?>">

    <p><?php echo _("You can change button labels (overriding FreePBX label) and privacy options (to prevent the button to be monitored and/or hide the CallerID) among other things. You can also sort the list by draggin elements");?></p>

<?php

$fopbutton = fop2_all_freepbx_buttons();

$fopsortedbuttons = array();
foreach ($fopbutton as $devname => $datarray) {
    if($sorting=="name") {
        $fopsortedbuttons[$devname]=$datarray['name'];
    } elseif($sorting=="number") {
        $fopsortedbuttons[$devname]=$datarray['exten'];
    } else {
        $fopsortedbuttons[$devname]=$datarray['sortorder'];
    }
}

asort($fopsortedbuttons);

$finalfopbutton=array();
foreach($fopsortedbuttons as $devname => $orden) {
   $finalfopbutton[$devname]=$fopbutton[$devname];
}

if($sorting <> "") {
    $vari = array();
    $conti = array();
    foreach($finalfopbutton as $device => $datarray) {
        if(!isset($conti[$datarray['type']])) { $conti[$datarray['type']]=1; } else { $conti[$datarray['type']]++;}
        $vari['listitem'][$conti[$datarray['type']]]=$datarray['exten'];
    }

/*    echo "<pre>";
    print_r($finalfopbutton);
    print_r($vari);
    echo "</pre>";*/
    
    fop2SetButtonOrder($vari);
    needreload();
}

$buttypes = array('extensions','queues','conferences','trunks','parks','ringgroups');

$privacyoptions = array("none","all","clid","monitor");

$ocultame = array();

foreach ($buttypes as $tipo) {
    if($tipo=="extensions") {
        $key="core";
    } else {
        $key=$tipo;
    }

    if($key<>"trunks") {
        $catname = sprintf("%s",isset($active_modules[$key]['name'])?$active_modules[$key]['name']:ucwords($key));
    } else {
        $catname='';
    }
    if($catname=="") $catname=ucfirst($tipo);
    if($catname=="Core") $catname="Extensions";

    $tipocorto = substr($tipo,0,-1);

    echo "<hr><table id='sorteame_$tipocorto' width='100%' class='fop2'><thead>";
    echo "<tr width='100%'><td colspan=\"6\" style='font-size:20px;'><br /><strong>"._($catname)."</strong></td></tr>";
    echo "</thead><tbody>";

    $conta=0;
    foreach ($finalfopbutton as $devname => $datarray) {

        $datarray = $fopbutton[$devname];
        if($datarray['type']==$tipo) {
            $conta++;
            $myitemid = $datarray['exten'];
            $myitemid = preg_replace("/OUT_/","trunkout",$myitemid);
            echo "<tr id='listitem_".$myitemid."'>";
            echo "<td><a href='#' class='info'><input type='checkbox' ";
            if($datarray['exclude']==1) { echo " checked "; }
            echo " name='excludebot_".$datarray['devid']."'><span>"._("If checked, it will  disable the button from the FOP2 panel.")."</span></a>";
            echo ($datarray['exten']==-1?'n/a':$datarray['exten'])."</td>";

            // Label & Group
            echo "<td>";
            echo "<a href='#' class='info' style='font-size:10px;'>"._("Label")."<span>"._("You can change the button label to be displayed on FOP2 panel.")."</span></a><br/><input type=text name='name_".$datarray['devid']."' value=\"".$datarray['name']."\" style='margin-bottom:10px;'><br/>";
            if($key=="core") {
                echo "<a href='#' class='info' style='font-size:10px;'>"._("Group")."<span>"._("You can group extensions visually on FOP2 page. If no group is specified all the extensions are going to be displayed on the Extensions box. If you type another name, a new box will be added with the name you choose. Any buttons with the same group name will be displayed on that box.")."</span></a><br/><input type=text name='group_".$datarray['devid']."' value='".$datarray['group']."'><br/>";
            }
            echo "</td>";

            // Privacy & Custom ASTDB
            if($key=="core" || $key=='trunks') {
            echo "<td>";
                echo "<a href='#' class='info' style='font-size:10px'>"._("Privacy")."<span>"._("This option can be used to disable monitoring or CallerID display on the button.")."</span></a><br/><select name='privacy_".$datarray['devid']."' style='margin-bottom:10px;'>";
                foreach($privacyoptions as $valor) {
                    echo "<option value='$valor' ";
                    if($datarray['privacy']==$valor) echo " selected ";
                    echo ">$valor</option>\n";
                }
                echo"</select><br/>";
            if($key=="core") {
                echo "<a href='#' class='info' style='font-size:10px'>"._("Custom ASTDB")."<span>"._("ASTDB key to search for custom states. Default configuration is for displaying Call Forward Unconditional states.")."</span></a><br/><input type=text name='customastdb_".$datarray['devid']."' value='".$datarray['customastdb']."'>";
            }
            echo "</td>";
            }


            if($key=="core") {

                // Email & Originate Channel
                echo "<td>";
                echo "<a href='#' class='info' style='font-size:10px'>"._("Email")."<span>"._("You can set an email for every button to enable the option to email the user directly from the FOP2 panel.")."</span></a><br/><input type=text name='email_".$datarray['devid']."' value='".$datarray['email']."' style='margin-bottom:10px;'><br/>";
                echo "<a href='#' class='info' style='font-size:10px'>"._("Originate Channel")."<span>"._("Channel to use as originator when performing a dial from FOP2. You can use a Local type channel and use sip headers for setting the phone to auto answer.")."</span></a><br/><input type=text name='originatechannel_".$datarray['devid']."' value='".$datarray['originatechannel']."'>";
                echo "</td>";

                // External Trasnfer & Chanspy Options
                echo "<td>";
                echo "<a href='#' class='info' style='font-size:10px'>"._("External Transfer")."<span>"._("number@context for external/mobile transfers. If @context is omited it will use the default one for the extension.")."</span></a><br/><input type=text name='external_".$datarray['devid']."' value='".$datarray['external']."' style='margin-bottom:10px;'><br/>"; 
                echo "<a href='#' class='info' style='font-size:10px'>"._("ChanSpy Options")."<span>"._("Options to pass to chanspy. Can be used to restrict spying to certain groups (option g, SPYGROUP) or silence the beep (option q). Example: qg(SALES)")."</span></a><br/><input type=text name='spyoptions_".$datarray['devid']."' value='".$datarray['spyoptions']."'>";
                echo "</td>";

                // Extra Channel & Tags
                echo "<td>";
                echo "<a href='#' class='info' style='font-size:10px'>"._("Channel")."<span>"._("Extra Channel. You can use it to add extra channels to affect the status of this button.")."</span></a><br/><input type=text name='channel_".$datarray['devid']."' value='".$datarray['channel']."' style='margin-bottom:10px;'><br/>";
                echo "<a href='#' class='info' style='font-size:10px'>"._("Tags")."<span>"._("Comma separated lists of tags. They will be searched/matched when you use the Filter input box on the panel.")."</span></a><br/><input type=text name='tags_".$datarray['devid']."' value='".$datarray['tags']."'>";
                echo "</td>";
                echo "</tr>";
                // echo "<td><a href='#' class='info' style='font-size:10px'>"._("Queue Channel")."<span>"._("Channel to use as queue member when adding/removing/pausing this button into a queue.")."</span></a><br/><input type=text name='queuechannel_".$datarray['devid']."' value='".$datarray['queuechannel']."'></td>";

            } else if($key=="trunks") {
                    if (eregi("dahdi",$datarray['customastdb']) or eregi("zap",$datarray['customastdb'])) {
                        echo "<td><a href='#' class='info' style='font-size:10px'>";
                        echo _("Zap/Dahdi Channels (Eg: 1-24)");
                        echo "<span>"._("You must specify the channel number range for zap/dahdi trunks in this field.")."</span></a>";
                        echo "<br/><input type=text name='email_".$datarray['devid']."' value='".$datarray['email']."'></td>";
                    } else {
                        echo "<td><a href='#' class='info' style='font-size:10px'>";
                        echo _("Extra Channel");
                        echo "<span>"._("You might want to specify an additional device name or put the correct device name in case you are using custom trunks.")."</span></a>";
                        echo "<br/><input type=text name='channel_".$datarray['devid']."' value='".$datarray['channel']."'></td>";
                    }

            } else {
                //echo "<td colspan=3>&nbsp;</td>";
            }
            echo "</tr>";
            //echo "<tr><td colspan=6><hr/></td></tr>";
        }
    }
    echo "</tbody></table>";
    if($conta==0) {
        $ocultame[$tipocorto]=1;
    }
}

?>

<p><?php echo _("If you changed any extension names and want to reread them from the regular FreePBX config and update the FOP2 config, click this button.");?></p>
<input name="RefreshLabel" type="submit" value="<?php echo _("Refresh Labels")?>" onclick="document.edit.action.value='refresh'; document.edit.submit(); return false;">
<p><?php echo _("To change the sort order for the all the buttons, you can click the following buttons. After changing the order you must Submit Changes. You can rearrange order by drag&drop on the above lists.");?></p>
<input name="SortName" type="submit" value="<?php echo _("Sort by Name")?>" onclick="document.edit.action.value='sortname'; document.edit.submit(); return false;">
<input name="SortNumber" type="submit" value="<?php echo _("Sort by Number")?>" onclick="document.edit.action.value='sortnumber'; document.edit.submit(); return false;">

<hr/>
<br><h6><input name="Submit" type="submit" value="<?php echo _("Submit Changes")?>" onclick="document.edit.submit(); return false;"></h6>

</form>
<div id='fop2info'></div>

<script language="javascript">
<!--

(function($){var a=$.ui.mouse.prototype._mouseMove;$.ui.mouse.prototype._mouseMove=function(b){if($.browser.msie&&document.documentMode>=9){b.button=1};a.apply(this,[b]);}}(jQuery));

function edit_onsubmit() {
    return true;
}

var fixHelper = function(e, ui) {
    ui.children().each(function() {
        $(this).width($(this).width());
    });
    return ui;
};

<?php

$myself = $_SERVER["PHP_SELF"]."?".$_SERVER['QUERY_STRING'];

foreach ($buttypes as $tipo) {
    $tipocorto = substr($tipo,0,-1);
    if(isset($ocultame[$tipocorto])) {
       echo "\$(\"#sorteame_$tipocorto\").hide();\n";
    } else {
?>
$("#sorteame_<?php echo $tipocorto;?> tbody").sortable({helper: fixHelper, update: function(event,ui) { serial = $('#sorteame_<?php echo $tipocorto;?> tbody').sortable('serialize'); $('#fop2info').load('<?php echo $myself;?>&action=sort&'+serial);}});

<?php
}
}
?>
//-->
</script>
