<?php /* $Id */
//Copyright (C) 2011 Nicolas Gudino <asternic@gmail.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of version 2 the GNU General Public
//License as published by the Free Software Foundation.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.


$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$itemid = isset($_REQUEST['itemid'])?$_REQUEST['itemid']:'';
$dispnum = "fop2groups";

$tabindex=0;

//if submitting form, update database
switch ($action) {
case "add":
	$result = fop2_add_group($_POST);

	if (!$result) {
		die();
	}
	needreload();
	redirect_standard();
	break;
case "delete":
	$oldItem = fop2_get_group($itemid);
	print_r($oldItem);
	fop2_del_group($itemid);
	needreload();
	redirect_standard();
	break;
case "edit":
	$result = fop2_edit_group($itemid,$_POST);
	if (!$result) {
		die();
	}
	needreload();
	redirect_standard('itemid');
	break;
}

$botonesdefinidos = fop2_list_botones();
$groups           = fop2_list_groups(0);

?>


<!-- right side menu -->
<div class="rnav"><ul>
    <li><a id="<?php echo ($itemid=='' ? 'current':'std') ?>" href="config.php?type=tool&display=<?php echo urlencode($dispnum)?>"><?php echo _("Add FOP2 Group") ?></a></li>
<?php
if (isset($groups)) {
	foreach ($groups as $d) {
		echo "<li><a id=\"".($itemid==$d['id'] ? 'current':'std')."\" href=\"config.php?type=tool&display=".urlencode($dispnum)."&itemid=".urlencode($d['id'])."\">{$d['name']}</a></li>";
	}
}
?>
</ul></div>

<div class="content">
<?php

if ($action == 'delete') {

	$str = sprintf("Group %s deleted",$oldItem["name"]);
	echo "<br/><h3>$str!</h3>";

} else {

	$thisItem   = fop2_get_group($itemid);
	$hisButtons = fop2_get_group_buttons($thisItem['name']);
	$delURL = $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'&action=delete';

?>
    <h2><?php echo ($itemid ? _("Edit FOP2 Group").": ".$thisItem["name"] : _("Add FOP2 Group")); ?></h2>
    <p><?php echo _("This module will let you manage FOP2 groups."); ?></p>
<?php
	if ($itemid) {
?>
    <p><a href="<?php echo $delURL ?>"><?php echo _("Delete FOP2 Group")?> '<?php echo $thisItem["name"]; ?>'</a></p>
<?php
	}
?>
<form autocomplete="off" name="edit" action="<?php $_SERVER['PHP_SELF'] ?>" method="post" onsubmit="return edit_onsubmit();">
    <input type="hidden" name="type"     value="tool">
    <input type="hidden" name="display"  value="<?php echo $dispnum?>">
    <input type="hidden" name="action"   value="<?php echo ($itemid ? 'edit' : 'add') ?>">
    <input type="hidden" name="deptname" value="<?php echo $_SESSION["AMP_user"]->_deptname ?>">
    <table>
    <tr><td colspan="2"><h5><?php echo ($itemid ? _("Edit Group") : _("Add Group")) ?><hr></h5></td></tr>

    <tr>
        <td><a href="#" class="info"><?php echo _("Name").":"?><span><?php echo _("The group name.")?></span></a></td>
        <td><input type="text" name="name" tabindex="<?php echo ++$tabindex;?>" value="<?php echo htmlspecialchars(isset($thisItem['name']) ? $thisItem['name'] : ""); ?>" ?></td>
    </tr>

<?php
}
?>
    <tr>
        <td colspan="2">
            <br/><h5><?php echo  _("Included Buttons")  ?><hr></h5><p><?php echo _("Select the buttons you want to include in this group."); ?></p>
        </td>
    </tr>

    <tr>
        <td>&nbsp;</td>
    </tr>
    <tr>
        <td colspan=2>
            <table width='500'>

<?php

$fopbutton = fop2_all_freepbx_buttons();

$buttypes = array('extensions','queues','conferences','trunks','parks','ringgroups');

foreach ($buttypes as $tipo) {
	if($tipo=="extensions") {
		$key="core";
	} else {
		$key=$tipo;
	}


	$catname = sprintf("%s",isset($active_modules[$key]['name'])?$active_modules[$key]['name']:ucwords($key));

	if($catname=="") $catname=ucfirst($tipo);
	if($catname=="Core") $catname="Extensions";

	$tipocorto = substr($tipo,0,-1);

	// Encabezado de Categoria
	if($tipocorto<>"extension") {
		echo "<tr width='100%'><td colspan='3'>&nbsp</td></tr>";
	}
	echo "<tr width='100%'><td colspan='2'><strong>"._($catname)."</strong></td>";
	echo "<td>";
	if($tipocorto=="extension") {
		echo "<a href='javascript:checkAll();'>"._("Check All")."</a>\n";
	} else {
		echo "&nbsp;";
	}
	echo "</td>";
	echo "</tr>";

	// Todos las extensiones
	foreach ($fopbutton as $devname => $datarray) {

		if($datarray['type']==$tipo) {

			echo "<tr>";
			echo "<td>".($datarray['exten']==-1?'n/a':$datarray['exten'])."</td>";
			echo "<td>".$datarray['name']."</td>";
			echo "<td><input type=checkbox name='includebot[]' value='".$devname."'";

			if(in_array($datarray['devid'],$hisButtons)) {
				echo " checked ";
			}

			echo"></td>";
			echo "</tr>";
		}
	}
}

?>
        </table>
        </td>
    </tr>

    <tr>
        <td colspan="2"><br><h6><input name="Submit" type="submit" value="<?php echo _("Submit Changes")?>"></h6></td>
    </tr>

    <tr>
        <td>&nbsp;</td>
    </tr>


    </table>
    </form>

<script language="javascript">
<!--

var theForm = document.edit;
theForm.name.focus();

function checkAll() {
    field = document.edit;
    for (i = 0; i < field.length; i++) {
        field[i].checked = !field[i].checked;
    }
}

function edit_onsubmit() {
    var msgEmptyGroupName = "<?php echo _('Please enter a group name.')?>";

    if (isEmpty(theForm.name.value)) {
        return warnInvalid(theForm.name, msgEmptyGroupName);
    }

    return true;
}

//-->
</script>
